from pandas import read_csv
from urllib.request import urlretrieve
from os import listdir, mkdir, makedirs, path as os_path
from tqdm import tqdm
from time import sleep
import requests
import pandas as pd

# télécharge les fichiers audio du fichier csv birds_france_test.csv

df = read_csv("creation_datasets/fichiers_csv/birds_france_test.csv")

# Removing recordings that are not classified
df = df[df['en'] != 'Identity unknown'].copy()
df = df[df['en'] != 'Soundscape'].copy()
counts = df['en'].value_counts()
print(counts)

print(len(df["en"].unique()), "different species")


makedirs('creation_datasets/audio_files_test_france', exist_ok='True')
audio_dir = 'creation_datasets/audio_files_test_france/'

nombre_audio = {}
for specie in df["en"].unique():
    nombre_audio[specie] = 0
print(nombre_audio)


nots = []

for row in tqdm(df.iterrows(), total=df.shape[0]):
    url = row[1]["file"]
    print(url)

    specie = row[1]["en"]

    if nombre_audio[specie] < 5:
        f_name = audio_dir + str(row[1]["id"]) + \
            row[1]["file-name"][-4:].lower()

        nombre_audio[specie] += 1
        print(specie, nombre_audio[specie])

        try:
            response = requests.get(url)
            open(f_name, 'wb').write(response.content)

        except Exception as e:
            print("\nRetrying:", url)
            print(e)
            sleep(1)
            try:
                response = requests.get(url)
                open(f_name, 'wb').write(response.content)
            except Exception as ee:
                print("Not downloaded|", f_name)
                print(ee)
                nots.append(row[1]["id"])
                pass

if len(nots) > 0:
    with open('not_downloaded.txt', 'w') as f:
        for item in nots:
            f.write(str(item) + '\n')
    print(str(nots))
else:
    print('All files were successfully downloaded!')
